import numpy as np
import sys
import matplotlib.pyplot as plt

filename = sys.argv[1]
data = np.loadtxt(filename,unpack=True)

if (sys.argv[2] == '3D'):
    plusindex = 7
    crossindex = 8
elif (sys.argv[2] == '2D'):
    plusindex = 9
    crossindex = 0

steps = 400
stepdt = 0.001
starttime = 0.05
windowtime = 0.05

kaiserwin = np.hanning(1001)
#print kaiserwin
#sys.exit

displayfreq = 75

maintime = np.arange(steps)*1.0
freq = np.arange(displayfreq)*1.0
heat = np.arange(steps*displayfreq).reshape(steps,displayfreq)*1.0

for i in range(0,steps,1):
#for i in range(0,50,2):
    maintime[i] = starttime + stepdt*i
    time = np.arange(2001.)/2.0e4 + starttime + stepdt*i - windowtime
    datatokaiser = np.interp(time,data[0],data[plusindex])
    datatokaiser2 = np.interp(time,data[0],data[crossindex])

    datatofft = np.zeros(1001)
    datatofft2 = np.zeros(1001)
    for jj in range(1001):
        datatofft[jj] = datatokaiser[jj+500]*kaiserwin[jj]
        datatofft2[jj] = datatokaiser2[jj+500]*kaiserwin[jj]

#    for ii in range(250,751):
#        for jj in range(501):
#            datatofft[jj] = datatofft[jj] + datatokaiser[ii-250+jj]*kaiserwin[jj]/501.

    fs = 1.0/5.0e-5
    
    ffteddata = np.fft.rfft(datatofft)
    ffteddata2 = np.fft.rfft(datatofft2)

    
    maxheat = -100
    for j in range(displayfreq):
        freq[j] = fs*j/1000.
        heat[i][j] = np.log((ffteddata[j].real)**2+(ffteddata[j].imag)**2+(ffteddata2[j].real)**2+(ffteddata2[j].imag)**2)/np.log(10.0)
#        heat[i][j] = ffteddata[j].real
#        print i,freq[j],heat[i][j]

#    print
#    print

def smooth(array,win):
    out = np.zeros(len(array))*1.0
    out[0] = (array[0]+array[1]+array[2]+array[3])/4.0
    out[1] = (array[0]+array[1]+array[2]+array[3]+array[4])/5.0
    out[2] = (array[0]+array[1]+array[2]+array[3]+array[4]+array[5])/6.0
    for i in range(win//2,len(array)-win//2):
        out[i] =  sum(array[i-3:i+4])/7.0
    out[len(array)-4] = (array[len(array)-1] + array[len(array)-2] + array[len(array)-3] + array[len(array)-4] + array[len(array)-5] + array[len(array)-6])/6.0
    out[len(array)-3] = (array[len(array)-1] + array[len(array)-2] + array[len(array)-3] + array[len(array)-4] + array[len(array)-5])/5.0
    out[len(array)-2] = (array[len(array)-1] + array[len(array)-2] + array[len(array)-3] + array[len(array)-4])/4.0
    out[len(array)-1] = (array[len(array)-1] + array[len(array)-2] + array[len(array)-3])/3.0
#    print array
#    print out
    return out

for j in range(displayfreq):
#    outheat = smooth((heat.T)[j],7)
    outheat = (heat.T)[j]
 #   sys.exit(0)

    for i in range(steps):
        heat[i][j] = outheat[i]
        if heat[i][j] > maxheat:
            maxheat = heat[i][j]


#heat = heat/np.amax(heat)
print maxheat, "using pert_3D max smoothed ouver 7 time bins", 5.1476854783
maxheat = 5.1476854783
heat = heat-maxheat        



for i in range(0,steps,1):
    
    for j in range(displayfreq):
        freq[j] = fs*j/1000.
#        heat[i][j] = np.log((ffteddata[j].real)**2)/np.log(10.0)
#        heat[i][j] = ffteddata[j].real
#        print i,freq[j],heat[i][j]

#    print
#    print

print freq[0],freq[-1],maintime[0],maintime[-1],maxheat

plt.imshow(np.transpose(heat), interpolation='none',vmin=-4,vmax=0,origin='lower',extent=[maintime[0],maintime[-1],freq[0],freq[-1]],aspect=1.0/4500.)
plt.xlabel(r"$t-t_\mathrm{bounce}$ [s]",fontsize=16)
plt.ylabel(r"Frequency [Hz]",fontsize=18)
ax = plt.gca()
plt.minorticks_on()
plt.title(sys.argv[3])
plt.tick_params(axis='x', which='both')
ax.tick_params(axis='both', labelsize=14)
plt.colorbar()
plt.savefig("spectro_"+sys.argv[3]+".pdf",bbox_inches='tight')
